# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/hwmon/adi,max31827.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Analog Devices MAX31827, MAX31828, MAX31829 Low-Power Temperature Switch

maintainers:
  - Daniel Matyas <daniel.matyas@analog.com>

description: |
  Analog Devices MAX31827, MAX31828, MAX31829 Low-Power Temperature Switch with
  I2C Interface
  https://www.analog.com/media/en/technical-documentation/data-sheets/MAX31827-MAX31829.pdf

properties:
  compatible:
    oneOf:
      - const: adi,max31827
      - items:
          - enum:
              - adi,max31828
              - adi,max31829
          - const: adi,max31827

  reg:
    maxItems: 1

  vref-supply:
    description:
      Must have values in the interval (1.6V; 3.6V) in order for the device to
      function correctly.

  adi,comp-int:
    description:
      If present interrupt mode is used. If not present comparator mode is used
      (default).
    type: boolean

  adi,alarm-pol:
    description:
      Sets the alarms active state.
            - 0 = active low
            - 1 = active high
    $ref: /schemas/types.yaml#/definitions/uint32
    enum: [0, 1]

  adi,fault-q:
    description:
      Select how many consecutive temperature faults must occur before
      overtemperature or undertemperature faults are indicated in the
      corresponding status bits.
    $ref: /schemas/types.yaml#/definitions/uint32
    enum: [1, 2, 4, 8]

  adi,timeout-enable:
    description:
      Enables timeout. Bus timeout resets the I2C-compatible interface when SCL
      is low for more than 30ms (nominal).
    type: boolean

allOf:
  - if:
      properties:
        compatible:
          contains:
            const: adi,max31829

    then:
      properties:
        adi,alarm-pol:
          default: 1

    else:
      properties:
        adi,alarm-pol:
          default: 0

  - if:
      properties:
        compatible:
          contains:
            const: adi,max31827

    then:
      properties:
        adi,fault-q:
          default: 1

    else:
      properties:
        adi,fault-q:
          default: 4

required:
  - compatible
  - reg
  - vref-supply

additionalProperties: false

examples:
  - |
    i2c {
        #address-cells = <1>;
        #size-cells = <0>;

        temperature-sensor@42 {
            compatible = "adi,max31827";
            reg = <0x42>;
            vref-supply = <&reg_vdd>;
            adi,comp-int;
            adi,alarm-pol = <0>;
            adi,fault-q = <1>;
            adi,timeout-enable;
        };
    };
...
